dnl
dnl Set TARGET_ARCH_*
dnl
AC_DEFUN([LAC_TARGET_ARCH],
[
GLOBUS_HOST=$host
AC_SUBST(GLOBUS_HOST)


case "$host" in
  *sunos5* | *solaris2* )
    AC_DEFINE([TARGET_ARCH_SOLARIS],[],[Solaris])
  ;;
  *-ibm-aix5* )
    AC_DEFINE([TARGET_ARCH_AIX],[],[AIX/AIX5])
    AC_DEFINE([TARGET_ARCH_AIX5],[],[AIX5])
  ;;
  *-*-hpux11*)
    AC_DEFINE([TARGET_ARCH_HPUX],[],[HPUX/HPUX11])
    AC_DEFINE([TARGET_ARCH_HPUX11],[],[HPUX11])
  ;;
  *-*-hpux* )
    AC_DEFINE([TARGET_ARCH_HPUX],[],[HPUX])
  ;;
  i*86-*-linux* )
    AC_DEFINE([TARGET_ARCH_LINUX],[],[Linux/x86])
    AC_DEFINE([TARGET_ARCH_X86],[],[Linux x86 platform])
  ;;
  *x86_64-*linux* )
    AC_DEFINE([TARGET_ARCH_LINUX],[],[Linux/x86_64])
    AC_DEFINE([TARGET_ARCH_X86_64],[],[Linux x86_64])
  ;;
  *ia64-*linux* )
    AC_DEFINE([TARGET_ARCH_LINUX],[],[Linux/ia64])
    AC_DEFINE([TARGET_ARCH_IA64],[],[Linux ia64])
  ;;
  alpha*-linux* )
    AC_DEFINE([TARGET_ARCH_LINUX],[],[Linux/Alpha])
    AC_DEFINE([TARGET_ARCH_AXP],[],[Linux AXP])
  ;;
  *freebsd* )
    AC_DEFINE([TARGET_ARCH_FREEBSD],[],[FreeBSD])
    AC_DEFINE([TARGET_ARCH_BSD],[],[FreeBSD/BSD])
  ;;
  *-darwin* )
    AC_DEFINE([TARGET_ARCH_DARWIN],[],[Darwin])
    AC_DEFINE([TARGET_ARCH_BSD],[],[Darwin/BSD])
  ;;
  i*86-*-cygwin* )
    AC_DEFINE([TARGET_ARCH_CYGWIN],[],[Cygwin])
    AC_DEFINE([TARGET_ARCH_X86],[],[Cygwin/x86])
  ;;
  sparc64-pc-linux-gnu )
    AC_DEFINE([TARGET_ARCH_LINUX],[],[Linux/Sparc64])
  ;;
  *-*-linux* )
    AC_DEFINE([TARGET_ARCH_LINUX],[],[Generic linux])
  ;;
  arm* )
    AC_DEFINE([TARGET_ARCH_NETOS],[],[NetOS/ARM])
    AC_DEFINE([TARGET_ARCH_ARM],[],[ARM])
  ;;
  *mingw32* )
    AC_DEFINE([TARGET_ARCH_WIN32],[],[Mingw32])
    AC_DEFINE([TARGET_ARCH_X86],[],[Mingw32/x86])
  ;;
  * )
	echo "platform not configured with TARGET_ARCH_*"
  ;;
esac
])

