dnl
dnl LAC_THREADS()
dnl     Adds thread-related options to the configure command-line handling
dnl     Set the appropriate lac_cv_* variables:
dnl             lac_cv_threads_type ("no", "pthreads", 
dnl                                     "solaristhreads")
dnl             lac_cv_threads_defines
dnl             lac_cv_threads_CFLAGS
dnl             lac_cv_threads_CXXFLAGS
dnl             lac_cv_threads_LDFLAGS
dnl             lac_cv_threads_LIBS
dnl     The *FLAGS and *LIBS variables should only be set to flags
dnl     that are independent of the compiler.  Compiler dependent
dnl     flags should be specified in accompiler.m4.
dnl     Also setup lac_threads_* variables that mirror the lac_cv_threads_*
dnl     variables.

dnl LAC_THREADS()
AC_DEFUN([LAC_THREADS_EXTRA],
[
LAC_THREADS_PTHREADS_EXTRA
LAC_THREADS_WINDOWS_EXTRA
])

dnl LAC_THREADS_PTHREADS
AC_DEFUN([LAC_THREADS_PTHREADS_EXTRA],
[
    AX_PTHREAD([build_pthreads=yes])
    AM_CONDITIONAL([BUILD_PTHREADS], [test "$build_pthreads" = "yes"])
])


dnl LAC_THREADS_WINDOWS
AC_DEFUN([LAC_THREADS_WINDOWS_EXTRA],
[
    found_inc="no"
    found_lib="no"
    found_compat_lib="no"

    windowsthreads_cflags=""
    windowsthreads_libs=""
    windowsthreads_ldflags=""

    case "$host" in
        *cygwin* | *mingw* [)]
            build_windows_threads="yes"
            ;;
    esac

    AM_CONDITIONAL([BUILD_WINDOWS_THREADS], [test "$build_windows_threads" = "yes"])
])
