/*
 * mdtm_msg.c
 *
 *  Created on: Mar 8, 2017
 *      Author: liangz
 */

#include "mdtm_msg.h"
#include <json.h>
#include <stdio.h>
#include <uuid/uuid.h>
#include "globus_libc.h"
#include "mdtm_ipc_msg.h"

void print_json_value(json_object *jobj){
  enum json_type type;
  type = json_object_get_type(jobj); /*Getting the type of the json object*/
  printf("type: %d",type);
  switch (type) {
    case json_type_boolean: printf("json_type_booleann");
                         printf("value: %sn", json_object_get_boolean(jobj)? "true": "false");
                         break;
    case json_type_double: printf("json_type_doublen");
                        printf("          value: %lfn", json_object_get_double(jobj));
                         break;
    case json_type_int: printf("json_type_intn");
                        printf("          value: %dn", json_object_get_int(jobj));
                         break;
    case json_type_string: printf("json_type_stringn");
                         printf("          value: %sn", json_object_get_string(jobj));
                         break;
    default:
        break;
  }

}

void json_parse_array( json_object *jobj, char *key) {
//  void json_parse(json_object * jobj); /*Forward Declaration*/
  enum json_type type;

  json_object *jarray = jobj; /*Simply get the array*/
  if(key) {
    jarray = json_object_object_get(jobj, key); /*Getting the array if it is a key value pair*/
  }

  int arraylen = json_object_array_length(jarray); /*Getting the length of the array*/
  printf("Array Length: %dn",arraylen);
  int i;
  json_object * jvalue;

  for (i=0; i< arraylen; i++){
    jvalue = json_object_array_get_idx(jarray, i); /*Getting the array element at position i*/
    type = json_object_get_type(jvalue);
    if (type == json_type_array) {
      json_parse_array(jvalue, NULL);
    }
    else if (type != json_type_object) {
      printf("value[%d]: ",i);
      print_json_value(jvalue);
    }
    else {
//      json_parse(jvalue);
    }
  }
}

int
mdtm_json_parse_param_launch(
    json_object * jobj_parm,
    mdtm_user_cmd_t * cmd)
{
  int                   rc = 0;
  enum json_type        type;
  char *                proxy_cred;

  json_object_object_foreach(jobj_parm, key, val) {
    /*Passing through every array element*/
    if(!strcmp(key, "task")) {
        cmd->params.launch.task = strdup(json_object_get_string(val));
    }
    else if(!strcmp(key, "files")) {
        json_object *jarray;
        int arraylen, i;
        json_object * jfile;

        jarray = json_object_object_get(jobj_parm, key);
        if((arraylen = json_object_array_length(jarray)) <= 0)
		return -1;
        cmd->params.launch.files =
            (mdtm_object_t*) globus_malloc(arraylen * sizeof(mdtm_object_t));
        cmd->params.launch.nfiles = arraylen;
        for (i=0; i< arraylen; i++) {
            jfile = json_object_array_get_idx(jarray, i); /*Getting the array element at position i*/
            type = json_object_get_type(jfile);
            if (type == json_type_array) {
                int n, nn = 0;
                json_object * jfileattr;

                n = json_object_array_length(jfile);
                jfileattr = json_object_array_get_idx(jfile, nn++);
                cmd->params.launch.files[i].path_src = strdup(json_object_get_string(jfileattr));
                jfileattr = json_object_array_get_idx(jfile, nn++);
                cmd->params.launch.files[i].path_dst = strdup(json_object_get_string(jfileattr));
                jfileattr = json_object_array_get_idx(jfile, nn++);
                cmd->params.launch.files[i].size = json_object_get_int64(jfileattr);
                jfileattr = json_object_array_get_idx(jfile, nn++);
                cmd->params.launch.files[i].offset = json_object_get_int64(jfileattr);
            }
        }
    }
    else if(!strcmp(key, "ip_src")) {
        cmd->params.launch.ip_src = strdup(json_object_get_string(val));
    }
    else if(!strcmp(key, "ip_dst")) {
        cmd->params.launch.ip_dst = strdup(json_object_get_string(val));
    }
    else if(!strcmp(key, "port_src")) {
        cmd->params.launch.port_src = json_object_get_int(val);
    }
    else if(!strcmp(key, "port_dst")) {
        cmd->params.launch.port_dst = json_object_get_int(val);
    }
    else if(!strcmp(key, "cert_src")) {
//        cmd->params.launch.cert_src = strdup("/tmp/x509up_u502");       //strdup(json_object_get_string(val));
    }
    else if(!strcmp(key, "cert_dst")) {
//        cmd->params.launch.cert_dst = strdup("/tmp/x509up_u502");       //strdup(json_object_get_string(val));
    }
    else if(!strcmp(key, "key_src")) {
        cmd->params.launch.key_src = strdup(json_object_get_string(val));
    }
    else if(!strcmp(key, "key_dst")) {
        cmd->params.launch.key_dst = strdup(json_object_get_string(val));
    }
    else if(!strcmp(key, "port_range_src")) {
        json_object *jobj_range;
        jobj_range = json_object_object_get(jobj_parm, key);
        json_object_object_foreach(jobj_range, key, val) {
          if(!strcmp(key, "min")) {
                  cmd->params.launch.port_range_src[0] = json_object_get_int(val);
              }
          else if(!strcmp(key, "max")) {
              cmd->params.launch.port_range_src[1] = json_object_get_int(val);
          }
        }
    }
    else if(!strcmp(key, "port_range_dst")) {
        json_object *jobj_range;
        jobj_range = json_object_object_get(jobj_parm, key);
        json_object_object_foreach(jobj_range, key, val) {
          if(!strcmp(key, "min")) {
                  cmd->params.launch.port_range_dst[0] = json_object_get_int(val);
              }
          else if(!strcmp(key, "max")) {
              cmd->params.launch.port_range_dst[1] = json_object_get_int(val);
          }
        }
    }
    else if(!strcmp(key, "url_scheme_src")) {
        cmd->params.launch.url_scheme_src = json_object_get_int(val);
    }
    else if(!strcmp(key, "url_scheme_dst")) {
        cmd->params.launch.url_scheme_dst = json_object_get_int(val);
    }
    else if(!strcmp(key, "usr_src")) {
        cmd->params.launch.usr_src = strdup(json_object_get_string(val));
    }
    else if(!strcmp(key, "pwd_src")) {
        cmd->params.launch.pwd_src = strdup(json_object_get_string(val));
    }
    else if(!strcmp(key, "usr_dst")) {
        cmd->params.launch.usr_dst = strdup(json_object_get_string(val));
    }
    else if(!strcmp(key, "pwd_dst")) {
        cmd->params.launch.pwd_dst = strdup(json_object_get_string(val));
    }
    else if(!strcmp(key, "proxy_credential_src")) {
        if((proxy_cred = getenv("MDTM_PROXY_CERT_SRC")) != NULL)
          cmd->params.launch.cert_src = strdup(proxy_cred);
        else {
            uuid_t  uu;
            char    uuid[37];
            FILE *  fp;

            uuid_generate(uu);
            uuid_unparse(uu, uuid);

            fp = fopen(uuid, "w+");
            if( fp == NULL ) {
                rc = -1;
                break;
            }
            fprintf(fp, "%s", json_object_get_string(val));
            fclose(fp);

            cmd->params.launch.cert_src = strdup(uuid);
        }
    }
    else if(!strcmp(key, "proxy_credential_dst")) {
        if((proxy_cred = getenv("MDTM_PROXY_CERT_DST")) != NULL)
          cmd->params.launch.cert_dst = strdup(proxy_cred);
        else {
            uuid_t  uu;
            char    uuid[37];
            FILE *  fp;

            uuid_generate(uu);
            uuid_unparse(uu, uuid);

            fp = fopen(uuid,"w+");
            if( fp == 0 ) {
                rc = -1;
                break;
            }
            fprintf(fp, "%s", json_object_get_string(val));
            fclose(fp);

            cmd->params.launch.cert_dst = strdup(uuid);
        }
    }
    else {
        printf("unknown token:%s\n", key);
    }

    if( rc < 0 )
      break;
  }
  return rc;
}

int
mdtm_json_parse_param_rate(
    json_object * jobj_parm,
    mdtm_user_cmd_t * cmd)
{
  int rc = 0;
//  enum json_type type;

  json_object_object_foreach(jobj_parm, key, val) {
    /*Passing through every array element*/
    if(!strcmp(key, "task")) {
        cmd->params.rate.task = strdup(json_object_get_string(val));
    }
    else {
        printf("unknown token:%s\n", key);
    }

    if( rc < 0 )
      break;
  }
  return rc;
}

int
mdtm_json_parse_param_status(
    json_object * jobj_parm,
    mdtm_user_cmd_t * cmd)
{
  int rc = 0;
//  enum json_type type;

  json_object_object_foreach(jobj_parm, key, val) {
    /*Passing through every array element*/
    if(!strcmp(key, "task")) {
        cmd->params.status.task = strdup(json_object_get_string(val));
    }
    else {
        printf("unknown token:%s\n", key);
    }

    if( rc < 0 )
      break;
  }
  return rc;
}

static
void
mdtm_json_print_cmd (mdtm_user_cmd_t *cmd)
{
  static int n = 0;

  printf("===== Parse Result %d =====\n", n++);
  switch (cmd->cmd_id) {
  case MDTM_USER_COMMAND_LAUNCH:
    printf("cmd: %d\n", cmd->cmd_id);
    printf("params:\n{\n");
    printf("\ttask: %s\n",cmd->params.launch.task);
    printf("\tfiles:[%s, ...]\n",cmd->params.launch.files[0].path_src);
    printf("\tip_src: %s\n", cmd->params.launch.ip_src);
    printf("\tip_dst: %s\n", cmd->params.launch.ip_dst);
    printf("\tport_src: %d\n", cmd->params.launch.port_src);
    printf("\tport_dst: %d\n", cmd->params.launch.port_dst);
    printf("\tport_range_src: { min: %d, max: %d}\n",cmd->params.launch.port_range_src[0], cmd->params.launch.port_range_src[1]);
    printf("\tport_range_dst: { min: %d, max: %d}\n",cmd->params.launch.port_range_dst[0], cmd->params.launch.port_range_dst[1]);
    printf("\tcert_src: %s\n", cmd->params.launch.cert_src);
    printf("\tcert_dst: %s\n", cmd->params.launch.cert_dst);
    printf("\tkey_src: %s\n", cmd->params.launch.key_src);
    printf("\tkey_dst: %s\n", cmd->params.launch.key_dst);
    printf("}\n");
    fflush(stdout);
    break;
  default:
    break;
  }
  printf("===== End Parse Result =====\n");
}

int
mdtm_json_parse(char * buffer, mdtm_user_cmd_t *cmd)
{
  int   rc = 0;
  json_object * jobj = NULL;
  json_object * jobj_parm;

  if(buffer == NULL || cmd == NULL)
    return -1;

  jobj = json_tokener_parse(buffer);
  if(jobj == NULL) {
    return -1;
  }

  cmd->cmd_id = MDTM_USER_COMMAND_UNKNOWN;
  json_object_object_foreach(jobj, key, val) {
    /*Passing through every array element*/
    if(!strcmp(key, "cmd")) {
//        printf("cmd: %s\n", json_object_get_string(val));
        if(!strcmp(json_object_get_string(val), "launch")){
            cmd->cmd_id = MDTM_USER_COMMAND_LAUNCH;
        }
//        else if(!strcmp(json_object_get_string(val), "pause")){
//            cmd->cmd_id = MDTM_USER_COMMAND_PAUSE;
//        }
        else if(!strcmp(json_object_get_string(val), "mld_rate")) {
            cmd->cmd_id = MDTM_USER_COMMAND_RATE;
        }
        else if(!strcmp(json_object_get_string(val), "status")) {
            cmd->cmd_id = MDTM_USER_COMMAND_STATUS;
        }
        else {
          cmd->cmd_id = MDTM_USER_COMMAND_UNKNOWN;
          printf("unknown cmd: %s\n", json_object_get_string(val));
          rc = -1;
        }
    }
    else if(!strcmp(key, "params")) {
        switch(cmd->cmd_id) {
        case MDTM_USER_COMMAND_LAUNCH:
          jobj_parm = json_object_object_get(jobj, key);
          rc = mdtm_json_parse_param_launch(jobj_parm, cmd);
          break;
        case MDTM_USER_COMMAND_RATE:
          jobj_parm = json_object_object_get(jobj, key);
          rc = mdtm_json_parse_param_rate(jobj_parm, cmd);
          break;
        case MDTM_USER_COMMAND_STATUS:
          rc = mdtm_json_parse_param_status(jobj_parm, cmd);
          break;
        default:
          printf("cmd missed or out-of-order.\n");
          rc = -1;
          break;
        }
    }
    else {
        printf("unknown token:%s\n", key);
    }

    if( rc < 0 )
      break;
  }

  json_object_put(jobj);        // release resource

//  if(rc >= 0 )
//	mdtm_json_print_cmd (cmd);

  return rc;
}

char *
mdtm_cmd_taskid(mdtm_user_cmd_t *cmd)
{
  return strdup(cmd->params.launch.task);
}

int
mdtm_msg_parse_request(
    char *              buffer,
    size_t              len,
    mdtm_user_cmd_t *   cmd)
{
  if(!buffer || len <=0 || !cmd)
    return -1;

  return mdtm_json_parse(buffer, cmd);
}


mdtm_msgq_message_t *
mdtm_msg_build_request(
    mdtm_user_cmd_t *          cmd)
{
  mdtm_msgq_message_t *      request;

  switch(cmd->cmd_id) {
  case MDTM_USER_COMMAND_STATUSREPORT:
    {
      if(cmd->params.status_report.nports > 0) {
          int min_port = 65536, max_port=-1, dstport, i;
          char port_buff[1024*1024], port_str[1024];

          memset(port_buff, 0, sizeof(port_buff)/sizeof(char));
          for(i = 0; i < cmd->params.status_report.nports -1; i++) {
              if (cmd->params.status_report.ports[i] > max_port )
                max_port = cmd->params.status_report.ports[i];
              if (cmd->params.status_report.ports[i] < min_port )
                min_port = cmd->params.status_report.ports[i];
              sprintf(port_str, "%d", cmd->params.status_report.ports[i]);
              strcat(port_buff, port_str);
              strcat(port_buff, ",");
          }
          port_buff[strlen(port_buff)-1] = '\0';
          dstport = cmd->params.status_report.ports[i];

          request = (mdtm_msgq_message_t *)globus_malloc(sizeof(mdtm_msgq_message_t) + MDTM_MSG_DEFAULT_SIZE);
          if(request == NULL)
            goto error_reponse;
          memset(request, 0, sizeof(mdtm_msgq_message_t) + MDTM_MSG_DEFAULT_SIZE);
          request->buffer = (char*)request + sizeof(mdtm_msgq_message_t);
#if 0
          sprintf(request->buffer,
              "{\"cmd\": \"%s\",\"params\":{\"task\": \"%s\",\"state\": %d,\"ports\":[{\"min\":%d,\"max\":%d},{\"min\":%d,\"max\":%d}]}}",
              "mld_status", cmd->params.status_report.task, cmd->params.status_report.state, min_port, max_port,dstport,dstport);
#else
          sprintf(request->buffer,
              "{\"cmd\": \"%s\",\"params\":{\"task\": \"%s\",\"state\": %d,\"ports_src\":[%s],\"ports_dst\":[%d]}}",
              "mld_status", cmd->params.status_report.task, cmd->params.status_report.state, port_buff,dstport);
#endif

      }
      else {
          request = (mdtm_msgq_message_t *)globus_malloc(sizeof(mdtm_msgq_message_t) + MDTM_MSG_DEFAULT_SIZE);
          if(request == NULL)
            goto error_reponse;

          memset(request, 0, sizeof(mdtm_msgq_message_t) + MDTM_MSG_DEFAULT_SIZE);
          request->buffer = (char*)request + sizeof(mdtm_msgq_message_t);

          sprintf(request->buffer,
              "{\"cmd\": \"%s\",\"params\":{\"task\": \"%s\",\"state\": %d,\"error_code\": %d}}",
              "mld_status", cmd->params.status_report.task, cmd->params.status_report.state, cmd->params.status_report.error_code);
      }
    }
    break;
  default:
    goto error_reponse;
    break;
  }

  request->buffer_len = strlen(request->buffer);

  return request;

error_reponse:
//  free(request);
  return 0;
}



mdtm_msgq_message_t *
mdtm_msg_build_response(
    mdtm_user_cmd_t *          cmd,
    mdtm_msgq_message_t *      in_msg,
    int                        result,
    void *                     data)
{
  mdtm_msgq_message_t *      response;

  response = (mdtm_msgq_message_t *)globus_malloc(sizeof(mdtm_msgq_message_t) + 64);
  memset(response, 0, sizeof(mdtm_msgq_message_t) + 64);
  response->buffer = (char*)response + sizeof(mdtm_msgq_message_t);

  switch(cmd->cmd_id) {
  case MDTM_USER_COMMAND_LAUNCH:
    {
      char *    taskid = (char *) data;
      sprintf(response->buffer,"{\"code\": %d, \"task\": \"%s\"}", result, taskid);
    }
    break;
  case MDTM_USER_COMMAND_RATE:
    {
      mdtm_msg_reponse_rate_t *   rate = (mdtm_msg_reponse_rate_t *)data;

      if(result == 0)
        sprintf(response->buffer,"{\"code\": %d, \"rate\": %f, \"transferred\":%lld}", result, rate->inst_rate/(1024*1024), (long long int)rate->total_bytes);
      else
        sprintf(response->buffer,"{\"code\": %d, \"rate\": %f, \"transferred\":%d}", result, 0.0, 0);
    }
    break;
  default:
    goto error_reponse;
    break;
  }

  response->buffer_len = strlen(response->buffer);
  response->reply_to = strdup(in_msg->reply_to);
  response->correlation_id = strdup(in_msg->correlation_id);
  response->result = result;

  return response;

error_reponse:
  free(response);
  return 0;
}

void
mdtm_msg_destroy_msg(mdtm_msgq_message_t * msg)
{
  if(!msg)
    return;

  if(msg->correlation_id)
    globus_free(msg->correlation_id);
  if(msg->reply_to)
    globus_free(msg->reply_to);
  globus_free(msg);
  return;
}
