/*
 * mdtm_man_thread.c
 *
 *  Created on: Jul 30, 2015
 *      Author: liangz
 */

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include <sys/syscall.h>
#include <globus_callback.h>
#include <globus_thread_pool.h>
#include <globus_libc.h>
#include <globus_thread_common.h>
#include <time.h>
//#include <globus_xio_system.h>
//#include "globus_ftp_control.h"
#include "mdtm.h"
#include "mdtm_rrd.h"
#include "mdtm_csv.h"
#include "mdtm_thread.h"
#include "mdtm_monitor.h"

void*
mdtm_man_thread(void *user_arg)
{
  globus_mutex_t                       globus_l_mutex;
  globus_cond_t                        globus_l_cond;
  globus_bool_t                        globus_l_closed = GLOBUS_FALSE;
  globus_condattr_t                    condattr;
  globus_callback_space_t              globus_l_space;
  mdtm_thread_user_data_t *            userdata;
  pthread_t                            threadid;
  mdtm_event_queue_t *                 eventq;

  mdtm_globus_l_callback_activate();

  globus_callback_space_init(&globus_l_space, NULL);
  globus_condattr_init(&condattr);
  globus_condattr_setspace(&condattr, globus_l_space);

  globus_mutex_init(&globus_l_mutex, NULL);
  globus_cond_init(&globus_l_cond, &condattr);

  // init thread event queue and save it to the global io table
  {
    struct mdtm_io_entry_s *ent = (struct mdtm_io_entry_s *)malloc(sizeof(struct mdtm_io_entry_s));

    userdata = (mdtm_thread_user_data_t*)user_arg;
    ent->devname = userdata->device_info->name;
    ent->tid = pthread_self();
    ent->type = userdata->device_info->classid;
    globus_fifo_init(&ent->eq.q);
    globus_mutex_init(&ent->eq._mutex, GLOBUS_NULL);
    assert(pthread_mutex_init(&ent->eq._pmutex, GLOBUS_NULL) == 0);
    userdata->io_table_register(userdata->io_table, ent);
    eventq = &ent->eq;
  }

  // save the space index to the xio system
//  mdtm_thread_globus_l_xio_system_activate(globus_l_space);
//  userdata->xio_act_func(globus_l_space);

  // initialize global rrd and csv files for mdtm monitor.
  mdtm_monitor_log_init();

  // register periodic tasks
  {
    globus_reltime_t                    period;

    // register polling of event queue
    GlobusTimeReltimeSet(period, 0, 50);
    globus_callback_space_register_periodic(
        NULL, //&mdtm_disk_read_callback_handle,
        0,
        &period,
        mdtm_eventq_poll,     //TODO: return type should be void rather than void*
        eventq,
        globus_l_space);

    // register periodic monitor logging
    if(mdtm_monitor_enabled()) {
        GlobusTimeReltimeSet(period, 15, 0);
        globus_callback_space_register_periodic(
            NULL, //&mdtm_disk_read_callback_handle,
            0,
            &period,
            mdtm_monitor_log_flush,     //TODO: return type should be void rather than void*
            NULL,
            globus_l_space);
    }
  }

  globus_mutex_lock(&globus_l_mutex);
  {
    while(!globus_l_closed)
      {
        globus_cond_wait(&globus_l_cond, &globus_l_mutex);
#if 0
        // poll the event queue
        // TODO: set continuing flag
        {
          //          globus_cond_timedwait(&eventq._cond, &eventq._mutex, 0);
          globus_mutex_lock(&eventq->_mutex);
          if(! globus_fifo_empty(&eventq->q))
            {
              /* Execute task */
              //              globus_l_thread_pool_active_threads++;
              //              globus_l_thread_pool_idle_threads--;
              task = globus_fifo_dequeue(&eventq->q);
              //              globus_l_thread_pool_pending_tasks--;

              globus_mutex_unlock(&eventq->_mutex);
              {
                task->func(task->func_user_arg);
                //                globus_thread_blocking_reset();
                //                globus_l_thread_pool_key_clean();
                //                globus_libc_free(task);
              }
              //              globus_mutex_lock(&eventq._mutex);

              //              globus_l_thread_pool_idle_threads++;
              //              globus_l_thread_pool_active_threads--;
              //              timeout = globus_i_abstime_infinity;
            }
          else
            globus_mutex_unlock(&eventq->_mutex);
        }
#endif
      }
  }
  globus_mutex_unlock(&globus_l_mutex);

  userdata->io_table_unregister(userdata->io_table, &threadid);

  //  globus_xio_attr_destroy(attr);
  //  globus_xio_stack_destroy(stack);

  globus_callback_space_destroy(globus_l_space);
  mdtm_globus_l_callback_deactivate();

  return 0;
}
