/*
 * mdtm_monitor.h
 *
 *  Created on: Sep 1, 2015
 *      Author: liangz
 */

#ifndef MDTM_MONITOR_H_
#define MDTM_MONITOR_H_

#include <netinet/in.h>
#include "mdtm.h"
#include "mdtm_rrd.h"

// default names of monitor logs
#define LOG_ROOT_DEFAULT        "/tmp/"
#define LOG_AGGR_RRD_IN         "mdtm-aggregate-in.rrd"
#define LOG_AGGR_RRD_OUT        "mdtm-aggregate-out.rrd"
#define LOG_AGGR_CSV_SNAP       "mdtm-snapshots.csv"
#define LOG_AGGR_CSV_COMPL      "mdtm-completed.csv"
#define LOG_CSV_SERVICE         "mdtm-service.csv"

typedef struct {
  struct {
    void *      rrd_indv;
    void *      rrd_aggr_in;
    void *      rrd_aggr_out;
    void *      csv_snapshot;
    void *      csv_completed;
  } file;
  union {
    mdtm_rrd_data_element_t *      rrd;
    void *                         csv;
  } data;
  int         sid;
  uid_t       uid;
  in_addr_t   src;
  in_addr_t   dst;
  size_t      size;
  size_t      xfr;
  int         in0out1;  //transfer direction: in:0 out:1
  char        filepath[512];
  void *      callback_handle;
} mdtm_xmit_progress_t;

char *
mdtm_monitor_getroot(int purge);

int
mdtm_monitor_getperiod();

int
mdtm_monitor_enabled();

void
mdtm_monitor_log_init();

void
mdtm_monitor_log_progress(void *user_data);

void
mdtm_monitor_log_progress_finished(void *user_data);

void
mdtm_monitor_log_flush(void *userdata);


#endif /* MDTM_MONITOR_H_ */
